///////////////////////////////////////////////////////////////////////////////
// DatagroupSectionHandler.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <cassert>
#include "SectionHandler.h"
#include "FileDatagroupRecord.h"
#include "FileDatagroupSection.h"

class VDatagroupSectionHandler : public VSectionHandler
{
protected:
	void WriteRecord(VFileDatagroupRecord * a_pRecord);
	SLONG WriteSectionBuffer();
	void WriteSectionTerminator();
	bool WriteSectionHeader(SLONG a_SectionLen, std::string a_strName);

public:
	VDatagroupSectionHandler(VExtendedFileWrapper & a_rFileWrapper);
	virtual ~VDatagroupSectionHandler();

	bool CanHandle(std::string a_strSectionName);

	EParseResult ReadSection(VFileContents & a_rContents, SLONG a_SectionLength);
	EParseResult ReadRecord(VFileDatagroupSection * a_pSection, SSHORT a_RecLen);

	void WriteSection(VFileSection * a_pSection);

	bool RewriteSection(VFileSection * a_pSection);
};

