///////////////////////////////////////////////////////////////////////////////
// FileDynamicRecord.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "FileRecord.h"
#include "FileDatagroupRecord.h"

class VFileDynamicRecord : public VFileRecord
{
private:
	SSHORT	m_DatagroupID;
	SLONG	m_FrameNumber;

	BYTE *	m_pDofValues;
	int		m_DofDataLen;
//	VFileDatagroupRecord * m_pDatagroupRec;

	bool IsValidIndex(int a_Index);

public:
	VFileDynamicRecord(BYTE * a_RawData, short a_sRecLen);
	VFileDynamicRecord(VFileDatagroupRecord * a_pDGRecord);
	virtual ~VFileDynamicRecord();

	virtual int CalculateLength() const;

	virtual void BuildRecordFromBytes();
	virtual SSHORT BuildBytesFromRecord();

	SSHORT GetDatagroupID() const { return m_DatagroupID; }
	SLONG  GetFrameNumber() const { return m_FrameNumber; }
	void   SetDatagroupID(SSHORT a_ID);
	void   SetFrameNumber(SLONG a_FrameNum);

	bool	GetDofValAsShort(int a_Index, SSHORT & a_rVal) const;
	bool	GetDofValAsLong(int a_Index, SLONG & a_rVal) const;
	bool	GetDofValAsFloat(int a_Index, float & a_rVal) const;
	bool	GetDofValAsDouble(int a_Index, double & a_rVal) const;
	bool 	GetDofValAsBinary(int a_Index, int a_NumBytes) const;
	bool	GetDofValAsBool(int a_Index, bool & a_rVal) const;

	void	SetDofValAsShort(int a_Index, SSHORT a_Val);
	void	SetDofValAsLong(int a_Index, SLONG a_Val);
	void	SetDofValAsFloat(int a_Index, float a_Val);
	void	SetDofValAsDouble(int a_Index, double a_Val);
	void	SetDofValAsBinary(int a_Index, BYTE * a_Val);
	void	SetDofValAsBool(int a_Index, bool a_Val);

	void SetDatagroupRecord(VFileDatagroupRecord * a_pRec);
};

