///////////////////////////////////////////////////////////////////////////////
// ThinFileWrapper.cpp
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#include "ThinFileWrapper.h"
#include <assert.h>
#include <iostream>
#include "Definitions.h"

VThinFileWrapper::VThinFileWrapper()
{
	m_pFileHandle = NULL;
//	m_OdometerCursor = 0;
}

VThinFileWrapper::~VThinFileWrapper()
{
	if (m_pFileHandle != NULL)
	{
		fflush(m_pFileHandle);
		fclose(m_pFileHandle);
		m_pFileHandle = NULL;
	}
}

bool VThinFileWrapper::OpenFile(std::string a_strFilename, std::string a_strMode)
{
	assert(m_pFileHandle == NULL);
	assert(a_strFilename != "");

	std::cout << "Attempting to open: " << a_strFilename << std::endl;
	m_pFileHandle = fopen(a_strFilename.c_str(), a_strMode.c_str());
		
	return m_pFileHandle != NULL;
}

void VThinFileWrapper::CloseFile()
{
	assert(m_pFileHandle != NULL);

	fclose(m_pFileHandle);
	m_pFileHandle = NULL;
}

bool VThinFileWrapper::Read(void * a_pBuffer, int a_Size)
{
	assert(a_pBuffer);
	assert(a_Size > 0);

	int NumRead = fread(a_pBuffer, sizeof(BYTE), a_Size, m_pFileHandle);

	return NumRead == a_Size;
}

bool VThinFileWrapper::Seek(int a_NumBytesToSkip, int a_Origin)
{
	assert(a_NumBytesToSkip >= 0);
	assert(a_Origin == SEEK_CUR || a_Origin == SEEK_SET || a_Origin == SEEK_END);

	return fseek(m_pFileHandle, a_NumBytesToSkip, a_Origin) == 0;
}

bool VThinFileWrapper::Write(const void * a_pBuffer, int a_Size)
{
	assert(a_pBuffer != NULL);
	assert(a_Size > 0);

	int NumWritten = fwrite(a_pBuffer, sizeof(BYTE), a_Size, m_pFileHandle);

	return NumWritten == a_Size;
}

/*
void VThinFileWrapper::ResetOdometer()
{
	m_OdometerCursor = ftell(m_pFileHandle);
}

long VThinFileWrapper::CheckOdometer()
{
	return ftell(m_pFileHandle) - m_OdometerCursor;
}
*/

