///////////////////////////////////////////////////////////////////////////////
// UnknownSectionHandler.cpp
// Paul Wilson
// Oxford Metrics, June 2000
///////////////////////////////////////////////////////////////////////////////

#include "UnknownSectionHandler.h"
#include "FileUnknownSection.h"

VUnknownSectionHandler::VUnknownSectionHandler(VExtendedFileWrapper & a_rFileWrapper) : VSectionHandler(a_rFileWrapper)
{

}

VUnknownSectionHandler::~VUnknownSectionHandler()
{

}

bool VUnknownSectionHandler::CanHandle(std::string a_strSectionName)
{
	return true;
}

VSectionHandler::EParseResult VUnknownSectionHandler::ReadSection(VFileContents & a_rContents, SLONG a_SectionLength)
{
	VSectionHandler::EParseResult eResult = ENoError;
	BYTE * pByteBuffer = new BYTE[a_SectionLength];

	if (pByteBuffer != NULL)
	{
		VFileUnknownSection * pSection = new VFileUnknownSection(a_SectionLength, "BODGE", pByteBuffer);

		if (pSection == NULL)
		{
			eResult = EOutOfMemory;
			delete [] pByteBuffer;
		}
	}
	else
	{
		eResult = EOutOfMemory;
	}

	return eResult;
}

void VUnknownSectionHandler::WriteSection(VFileSection * a_pSection)
{

}

bool VUnknownSectionHandler::RewriteSection(VFileSection * a_pSection)
{
	return false;
}

bool VUnknownSectionHandler::WriteSectionHeader(SLONG a_SectionLen, std::string a_strName)
{
	return false;
}

